<template>
  <sui-modal
    v-model="visible"
    v-scroll-lock="visible"
    v-dom-move
    size="standart"
    :animation-duration="1"
    class="google-map">
    <i
      class="close icon"
      @click="visible = false"/>
    <div class="header default padding gray">

      <div
        class="title"
        v-if="markers.length > 1"> Филиалы на карте</div>
      <div
        class="title"
        v-else> Магазин на карте</div>

    </div>
    <div class="content">
      <div class="map container">
        <GmapMap
          ref="mapRef"
          :options="map.options"
          :center="{lat:0 , lng:0}"
          :zoom="map.zoom"
          map-type-id="roadmap"
          class="kit map">
          <GmapMarker
            v-for="(marker, index) in markers"
            :key="index"
            :clickable="true"
            :position="{ lat: marker.lat, lng: marker.lng }"
            @click="openInfoWindow(index)"/>
          <GmapInfoWindow
            :options="{maxWidth: 300}"
            :position="infoWindow.position"
            :opened="infoWindow.open"
            @closeclick="infoWindow.open = false">
            <div class="kit info window">
              <div class="title">{{ infoWindow.title }}</div>
              <div class="info-window-content">{{ infoWindow.content }}</div>
            </div>
          </GmapInfoWindow>
        </GmapMap>
      </div>
    </div>
  </sui-modal>
</template>


<script>
export default {
  name: 'GoogleMap',
  props: {
    value: {
      type: Boolean,
      default: false,
    },
    markers: {
      type: Array,
      default() { return []; },
    },
  },
  data() {
    return {
      map: {
        options: {
          mapTypeControl: false,
          streetViewControl: true,
          clickableIcons: true,
          rotateControl: true,
          fullscreenControl: true,
          disableDoubleClickZoom: false,
          minZoom: 3,
          maxZoom: 16,
        },
        zoom: 5,
        bounds: null,
      },
      infoWindow: {
        position: { lat: 0, lng: 0 },
        open: false,
        title: '',
        content: '',
      },
    };
  },
  computed: {
    visible: {
      get() {
        return this.value;
      },
      set(newVal) {
        if (newVal) {
          this.$emit('input', true);
        } else {
          this.$emit('input', false);
        }
      },
    },
  },
  mounted() {
    this.$refs.mapRef.$mapPromise.then(() => {
      const bounds = new window.google.maps.LatLngBounds();
      this.markers.map((markerAll) => {
        bounds.extend(new window.google.maps.LatLng(markerAll.lat, markerAll.lng));
        this.$refs.mapRef.fitBounds(bounds);
        return true;
      });
    });
  },
  methods: {
    openInfoWindow(index) {
      const marker = this.markers[index];
      this.infoWindow.position = { lat: marker.lat, lng: marker.lng };
      this.infoWindow.title = marker.infoWindowTitle;
      this.infoWindow.content = marker.infoWindowContent;
      this.infoWindow.open = true;
    },
  },
};

</script>

<style scoped lang="scss">
  .google-map {
    padding: 0;

    .content {
      height: 530px;
      padding: 0 !important;
      overflow: hidden;
      @media only screen and (max-width: 1024px) {
        height: 88%;
      }
      @media only screen and (max-height: 568px) {
        height: 86%;
      }
    }

    .map.container {
      width: 100%;
      height: 100%;

      .kit {
        position: relative;
        width: 100%;
        height: 100%;

        .kit.info.window {
          display: inline-block;
          overflow: auto;
          max-height: 452px;
          max-width: 654px;

          > .title {
            padding-left: 0;
            margin-bottom: 10px;
            min-width: 100%;
            font-weight: 700;
            margin-top: 5px;
          }

          > .info-window-content {
            margin-bottom: 12px;
            color: #6a7b87;
            border-bottom: 1px solid #dee7ed;
            padding-bottom: 7px;
          }
        }
      }
    }
  }

</style>
